#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include "base64.h"


static uint8_t b64code(uint8_t V)
{
  V &= 63;
  if (V<26) return 'A'+V; V-= 26;
  if (V<26) return 'a'+V; V-= 26;
  if (V<10) return '0'+V; V-= 10;
  if (V<1)  return '+';
  return '/';
}

static uint8_t b64val(uint8_t X)
{
  if (X>='A' && X<='Z') return X-'A';
  if (X>='a' && X<='z') return X-'a'+26;
  if (X>='0' && X<='9') return X-'0'+52;
  if (X=='+') return 62;
  if (X=='/') return 63;
  return 0;
}

int b64_decode(uint8_t *buffer, int len)
{
  uint8_t bits= 0;
  uint16_t inp, oup,V;

  inp= oup= V= 0;
  while(1)
    if (bits>=8)
    {
      buffer[oup++]= V>>(bits-8);
      bits-= 8;
    }
    else
    {
      if (inp==len) return oup;
      V= (V<<6) | b64val(buffer[inp]);
      bits+= 6;
      inp++;
    }
}

int b64_encoded_len(int mlen)
{
  return  (mlen*8+5)/6;
}

static uint16_t B64v;
static uint8_t  B64bits;
static uint8_t *B64buffer;
static int     *B64len;

void b64_encode_begin(uint8_t *buffer, int *len)
{
  *len= 0;
  B64len= len;
  B64buffer= buffer;
  B64bits= 0;
  B64v= 0;
}

static void output(uint8_t K)
{
  B64buffer[*B64len]= K;
  *B64len+= 1;
}

static void output_bits()
{
  while(B64bits>=6)
  {
    output( b64code(B64v>>(B64bits-6)) );  
    B64bits -= 6;
  }
}

void b64_encode(uint8_t C)
{
  output_bits();
  B64v= (B64v<<8) | C;
  B64bits+= 8;
  output_bits();
}

void b64_encode_end()
{
  output_bits();
  if (!B64bits) return ;
  B64v &=  (1<<B64bits) - 1;
  output( b64code( B64v << (6-B64bits)) );
}
