#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "sock.h"
#include "gfx.h"

int sock_connect(char *host,int port) 
{
  int s;
  struct sockaddr_in addr;
  int len;

  s= socket(PF_INET, SOCK_STREAM, 0);
  if (s<0) return -1;

  len= sizeof(addr);
  memset(&addr, 0, sizeof(addr));
  addr.sin_family= AF_INET;
  addr.sin_port= htons( (short) port);
  inet_aton(host,&addr.sin_addr);
  if (connect(s,(struct sockaddr*) &addr, len))
  {
    gfx_logview_printf(Wlog,"connect: %s\n", strerror(errno));
    close(s);
    return -1;
  }
  gfx_logview_printf(Wlog,"connected %s:%d\n", host, port);
  return s;
}

void sock_close(int sock) 
{
  shutdown(sock,3);
  close(sock);
}

int sock_send(int sock, char *m, int len) 
{
  int r;
  while(len) 
  {
    r= send(sock, m, len, MSG_NOSIGNAL);
    if (r<=0)
    {
      if (errno==EINTR) continue;
      gfx_logview_printf(Wlog, "send: %s\n", strerror(errno));
      return -1;
    }
    len-= r;
    m+= r;
  }
  return 0;
}


int sock_recv(int s,char *z,int len)
{
  int r;
  r= recv(s,z,len,MSG_NOSIGNAL);
  if (r>0) return r;
  gfx_logview_printf(Wlog,"recv: %s\n", strerror(errno));
  return -1;
}
