#!/bin/sh

# fuses:
# hi fuse ( page 227 )
# bit -digit- value - hexdig - meaning
#  7    8      1               PC6 is RESET pin
#  6    4      1               WDT not always on
#  5    2      0               Serial programming enabled
#  4    1      0       c       CKOPT
#  3    8      1               EEPROM erased when chip erase
#  2    4      0               boot size   - default value
#  1    2      0               boot size   - default value
#  0    1      1       9       reset vector- default value
#
# lo fuse   ( page 228 )
# bit -digit- value - hexdig - meaning
#  7    8      1               BOD - default
#  6    4      1               BOD - default
#  5    2      1               SUT1
#  4    1      1       f       SUT0
#  3    8      1               CKSEL3
#  2    4      1               CKSEL2
#  1    2      0               CKSEL1
#  0    1      1       d       CKSEL0
#
# Clock Source:
#
# CKSEL3:1 = 110      (page 26)  These two values select crystal 
# CKOPT    = 0        (page 26)  oscillator with F>=1.0 Mhz
#
# SUT1:0   = 11       (page 27)  Select 65 ms startup time with
# CKSEL0   = 1        (page 27)  16K clock cycles
#
~/PRG/avrdude-5.11/bin/avrdude -p m8 -c usbasp  -U hfuse:w:0xc9:m
~/PRG/avrdude-5.11/bin/avrdude -p m8 -c usbasp  -U lfuse:w:0xfd:m

