
#include <avr/io.h>
#include "../i2cmaster-soft/i2cmaster.h"
#include "pcom.h"
#include "../firmware/fiface.h"

#define DEVADDR  (PCOM_ADDR<<1)

void pcom_init()
{
   i2c_init();
}

static uint8_t readreg(uint8_t reg, uint8_t *RV)
{
  uint8_t F= 1;
  if (i2c_start(DEVADDR+I2C_WRITE))    goto fin;
  if (i2c_write(reg))                  goto fin;
  if (i2c_rep_start(DEVADDR+I2C_READ)) goto fin;
  F= 0;
  *RV= i2c_readNak();
fin:
  i2c_stop();
  return F;
}

static uint8_t getsize(uint8_t reg, uint8_t len)
{
  uint8_t maxlen;
  if (readreg(reg,&maxlen)) return 0;
  if (maxlen>32) maxlen= 0;
  if (len>maxlen) len= maxlen;
  return len;
}

uint8_t pcom_send(uint8_t *data, uint8_t len)
{
  uint8_t i;

  i= 0;
  len= getsize(DIO_REG_WSIZE, len);
  if (!len) return 0;

  if (i2c_start(DEVADDR+I2C_WRITE)) goto fin;
  if (i2c_write(DIO_REG_BUFFER))    goto fin;
  for(i=0;i<len;i++) if (i2c_write(data[i])) break;  
fin:
  i2c_stop();
  return i;
}

uint8_t pcom_recv(uint8_t *data, uint8_t len)
{
  uint8_t i;
  i= 0;
  len= getsize(DIO_REG_RSIZE, len);
  if (!len) return 0;

  if (i2c_start(DEVADDR+I2C_WRITE))    goto fin; 
  if (i2c_write(DIO_REG_BUFFER))       goto fin; 
  if (i2c_rep_start(DEVADDR+I2C_READ)) goto fin;

  for(i=0;i<len;i++) data[i]= i2c_read(i!=len-1);
fin:
  i2c_stop();
  return i;
}
